<?php

namespace CreoCode\ContaoTourismBundle\Models;

use Contao\Model\Collection;

use Contao\Model;
use Contao\Date;

/**
 * Reads and writes accommodations
 *
 * @property integer $id
 * @property integer $pid
 * @property integer $tstamp
 * @property string  $headline
 * @property string  $alias
 * @property integer $author
 * @property integer $date
 * @property integer $time
 * @property string  $pageTitle
 * @property string  $description
 * @property string  $subheadline
 * @property string  $teaser
 * @property boolean $addImage
 * @property string  $singleSRC
 * @property string  $alt
 * @property string  $size
 * @property string  $imagemargin
 * @property string  $imageUrl
 * @property boolean $fullsize
 * @property string  $caption
 * @property string  $floating
 * @property string  $source
 * @property integer $jumpTo
 * @property integer $articleId
 * @property string  $url
 * @property boolean $target
 * @property string  $cssClass
 * @property boolean $featured
 * @property boolean $published
 * @property string  $start
 * @property string  $stop
 *
 * @method static AccommodationsModel|null findById($id, array $opt=array())
 * @method static AccommodationsModel|null findByPk($id, array $opt=array())
 * @method static AccommodationsModel|null findByIdOrAlias($val, array $opt=array())
 * @method static AccommodationsModel|null findOneBy($col, $val, array $opt=array())
 * @method static AccommodationsModel|null findOneByPid($val, array $opt=array())
 * @method static AccommodationsModel|null findOneByTstamp($val, array $opt=array())
 * @method static AccommodationsModel|null findOneByHeadline($val, array $opt=array())
 * @method static AccommodationsModel|null findOneByAlias($val, array $opt=array())
 * @method static AccommodationsModel|null findOneByAuthor($val, array $opt=array())
 * @method static AccommodationsModel|null findOneByDate($val, array $opt=array())
 * @method static AccommodationsModel|null findOneByTime($val, array $opt=array())
 * @method static AccommodationsModel|null findOneByPageTitle($val, array $opt=array())
 * @method static AccommodationsModel|null findOneByDescription($val, array $opt=array())
 * @method static AccommodationsModel|null findOneBySubheadline($val, array $opt=array())
 * @method static AccommodationsModel|null findOneByTeaser($val, array $opt=array())
 * @method static AccommodationsModel|null findOneByAddImage($val, array $opt=array())
 * @method static AccommodationsModel|null findOneBySingleSRC($val, array $opt=array())
 * @method static AccommodationsModel|null findOneByAlt($val, array $opt=array())
 * @method static AccommodationsModel|null findOneBySize($val, array $opt=array())
 * @method static AccommodationsModel|null findOneByImagemargin($val, array $opt=array())
 * @method static AccommodationsModel|null findOneByImageUrl($val, array $opt=array())
 * @method static AccommodationsModel|null findOneByFullsize($val, array $opt=array())
 * @method static AccommodationsModel|null findOneByCaption($val, array $opt=array())
 * @method static AccommodationsModel|null findOneByFloating($val, array $opt=array())
 * @method static AccommodationsModel|null findOneBySource($val, array $opt=array())
 * @method static AccommodationsModel|null findOneByJumpTo($val, array $opt=array())
 * @method static AccommodationsModel|null findOneByArticleId($val, array $opt=array())
 * @method static AccommodationsModel|null findOneByUrl($val, array $opt=array())
 * @method static AccommodationsModel|null findOneByTarget($val, array $opt=array())
 * @method static AccommodationsModel|null findOneByCssClass($val, array $opt=array())
 * @method static AccommodationsModel|null findOneByFeatured($val, array $opt=array())
 * @method static AccommodationsModel|null findOneByPublished($val, array $opt=array())
 * @method static AccommodationsModel|null findOneByStart($val, array $opt=array())
 * @method static AccommodationsModel|null findOneByStop($val, array $opt=array())
 *
 * @method static Collection|AccommodationsModel[]|AccommodationsModel|null findByPid($val, array $opt=array())
 * @method static Collection|AccommodationsModel[]|AccommodationsModel|null findByTstamp($val, array $opt=array())
 * @method static Collection|AccommodationsModel[]|AccommodationsModel|null findByHeadline($val, array $opt=array())
 * @method static Collection|AccommodationsModel[]|AccommodationsModel|null findByAlias($val, array $opt=array())
 * @method static Collection|AccommodationsModel[]|AccommodationsModel|null findByAuthor($val, array $opt=array())
 * @method static Collection|AccommodationsModel[]|AccommodationsModel|null findByDate($val, array $opt=array())
 * @method static Collection|AccommodationsModel[]|AccommodationsModel|null findByTime($val, array $opt=array())
 * @method static Collection|AccommodationsModel[]|AccommodationsModel|null findByPageTitle($val, array $opt=array())
 * @method static Collection|AccommodationsModel[]|AccommodationsModel|null findByDescription($val, array $opt=array())
 * @method static Collection|AccommodationsModel[]|AccommodationsModel|null findBySubheadline($val, array $opt=array())
 * @method static Collection|AccommodationsModel[]|AccommodationsModel|null findByTeaser($val, array $opt=array())
 * @method static Collection|AccommodationsModel[]|AccommodationsModel|null findByAddImage($val, array $opt=array())
 * @method static Collection|AccommodationsModel[]|AccommodationsModel|null findBySingleSRC($val, array $opt=array())
 * @method static Collection|AccommodationsModel[]|AccommodationsModel|null findByAlt($val, array $opt=array())
 * @method static Collection|AccommodationsModel[]|AccommodationsModel|null findBySize($val, array $opt=array())
 * @method static Collection|AccommodationsModel[]|AccommodationsModel|null findByImagemargin($val, array $opt=array())
 * @method static Collection|AccommodationsModel[]|AccommodationsModel|null findByImageUrl($val, array $opt=array())
 * @method static Collection|AccommodationsModel[]|AccommodationsModel|null findByFullsize($val, array $opt=array())
 * @method static Collection|AccommodationsModel[]|AccommodationsModel|null findByCaption($val, array $opt=array())
 * @method static Collection|AccommodationsModel[]|AccommodationsModel|null findByFloating($val, array $opt=array())
 * @method static Collection|AccommodationsModel[]|AccommodationsModel|null findBySource($val, array $opt=array())
 * @method static Collection|AccommodationsModel[]|AccommodationsModel|null findByJumpTo($val, array $opt=array())
 * @method static Collection|AccommodationsModel[]|AccommodationsModel|null findByArticleId($val, array $opt=array())
 * @method static Collection|AccommodationsModel[]|AccommodationsModel|null findByUrl($val, array $opt=array())
 * @method static Collection|AccommodationsModel[]|AccommodationsModel|null findByTarget($val, array $opt=array())
 * @method static Collection|AccommodationsModel[]|AccommodationsModel|null findByCssClass($val, array $opt=array())
 * @method static Collection|AccommodationsModel[]|AccommodationsModel|null findByFeatured($val, array $opt=array())
 * @method static Collection|AccommodationsModel[]|AccommodationsModel|null findByPublished($val, array $opt=array())
 * @method static Collection|AccommodationsModel[]|AccommodationsModel|null findByStart($val, array $opt=array())
 * @method static Collection|AccommodationsModel[]|AccommodationsModel|null findByStop($val, array $opt=array())
 * @method static Collection|AccommodationsModel[]|AccommodationsModel|null findMultipleByIds($val, array $opt=array())
 * @method static Collection|AccommodationsModel[]|AccommodationsModel|null findBy($col, $val, array $opt=array())
 * @method static Collection|AccommodationsModel[]|AccommodationsModel|null findAll(array $opt=array())
 *
 * @method static integer countById($id, array $opt=array())
 * @method static integer countByPid($val, array $opt=array())
 * @method static integer countByTstamp($val, array $opt=array())
 * @method static integer countByHeadline($val, array $opt=array())
 * @method static integer countByAlias($val, array $opt=array())
 * @method static integer countByAuthor($val, array $opt=array())
 * @method static integer countByDate($val, array $opt=array())
 * @method static integer countByTime($val, array $opt=array())
 * @method static integer countByPageTitle($val, array $opt=array())
 * @method static integer countByDescription($val, array $opt=array())
 * @method static integer countBySubheadline($val, array $opt=array())
 * @method static integer countByTeaser($val, array $opt=array())
 * @method static integer countByAddImage($val, array $opt=array())
 * @method static integer countBySingleSRC($val, array $opt=array())
 * @method static integer countByAlt($val, array $opt=array())
 * @method static integer countBySize($val, array $opt=array())
 * @method static integer countByImagemargin($val, array $opt=array())
 * @method static integer countByImageUrl($val, array $opt=array())
 * @method static integer countByFullsize($val, array $opt=array())
 * @method static integer countByCaption($val, array $opt=array())
 * @method static integer countByFloating($val, array $opt=array())
 * @method static integer countBySource($val, array $opt=array())
 * @method static integer countByJumpTo($val, array $opt=array())
 * @method static integer countByArticleId($val, array $opt=array())
 * @method static integer countByUrl($val, array $opt=array())
 * @method static integer countByTarget($val, array $opt=array())
 * @method static integer countByCssClass($val, array $opt=array())
 * @method static integer countByFeatured($val, array $opt=array())
 * @method static integer countByPublished($val, array $opt=array())
 * @method static integer countByStart($val, array $opt=array())
 * @method static integer countByStop($val, array $opt=array())
 */
class AccommodationsModel extends Model
{

	/**
	 * Table name
	 * @var string
	 */
	protected static $strTable = 'tl_accommodations';

	/**
	 * Find a published accommodations item from one or more accommodations archives by its ID or alias
	 *
	 * @param mixed $varId      The numeric ID or alias name
	 * @param array $arrPids    An array of parent IDs
	 * @param array $arrOptions An optional options array
	 *
	 * @return AccommodationsModel|null The model or null if there are no accommodations
	 */
	public static function findPublishedByParentAndIdOrAlias($varId, $arrPids, array $arrOptions=array())
	{
		if (empty($arrPids) || !\is_array($arrPids))
		{
			return null;
		}

		$t = static::$strTable;
		$arrColumns = !preg_match('/^[1-9]\d*$/', $varId) ? array("$t.alias=?") : array("$t.id=?");
		$arrColumns[] = "$t.pid IN(" . implode(',', array_map('\intval', $arrPids)) . ")";

		if (!static::isPreviewMode($arrOptions))
		{
			$time = Date::floorToMinute();
			$arrColumns[] = "($t.start='' OR $t.start<='$time') AND ($t.stop='' OR $t.stop>'" . ($time + 60) . "') AND $t.published='1'";
		}

		return static::findOneBy($arrColumns, $varId, $arrOptions);
	}

	/**
	 * Find published accommodations items by their parent ID
	 *
	 * @param array   $arrPids     An array of accommodations archive IDs
	 * @param boolean $blnFeatured If true, return only featured accommodations, if false, return only unfeatured accommodations
	 * @param integer $intLimit    An optional limit
	 * @param integer $intOffset   An optional offset
	 * @param array   $arrOptions  An optional options array
	 *
	 * @return Collection|AccommodationsModel[]|AccommodationsModel|null A collection of models or null if there are no accommodations
	 */
	public static function findPublishedByPids($arrPids, $blnFeatured=null, $intLimit=0, $intOffset=0, array $arrOptions=array())
	{
		if (empty($arrPids) || !\is_array($arrPids))
		{
			return null;
		}

		$t = static::$strTable;
		$arrColumns = array("$t.pid IN(" . implode(',', array_map('\intval', $arrPids)) . ")");

		if ($blnFeatured === true)
		{
			$arrColumns[] = "$t.featured='1'";
		}
		elseif ($blnFeatured === false)
		{
			$arrColumns[] = "$t.featured=''";
		}

		// Never return unpublished elements in the back end, so they don't end up in the RSS feed
		if (!BE_USER_LOGGED_IN || TL_MODE == 'BE')
		{
			$time = Date::floorToMinute();
			$arrColumns[] = "($t.start='' OR $t.start<='$time') AND ($t.stop='' OR $t.stop>'" . ($time + 60) . "') AND $t.published='1'";
		}

		if (!isset($arrOptions['order']))
		{
			$arrOptions['order']  = "$t.sorting DESC";
		}

		$arrOptions['limit']  = $intLimit;
		$arrOptions['offset'] = $intOffset;

		return static::findBy($arrColumns, null, $arrOptions);
	}

	/**
	 * Count published accommodations items by their parent ID
	 *
	 * @param array   $arrPids     An array of accommodations archive IDs
	 * @param boolean $blnFeatured If true, return only featured accommodations, if false, return only unfeatured accommodations
	 * @param array   $arrOptions  An optional options array
	 *
	 * @return integer The number of accommodations items
	 */
	public static function countPublishedByPids($arrPids, $blnFeatured=null, array $arrOptions=array())
	{
		if (empty($arrPids) || !\is_array($arrPids))
		{
			return 0;
		}

		$t = static::$strTable;
		$arrColumns = array("$t.pid IN(" . implode(',', array_map('\intval', $arrPids)) . ")");

		if ($blnFeatured === true)
		{
			$arrColumns[] = "$t.featured='1'";
		}
		elseif ($blnFeatured === false)
		{
			$arrColumns[] = "$t.featured=''";
		}

		if (!static::isPreviewMode($arrOptions))
		{
			$time = Date::floorToMinute();
			$arrColumns[] = "($t.start='' OR $t.start<='$time') AND ($t.stop='' OR $t.stop>'" . ($time + 60) . "') AND $t.published='1'";
		}

		return static::countBy($arrColumns, null, $arrOptions);
	}

	/**
	 * Find published accommodations items with the default redirect target by their parent ID
	 *
	 * @param integer $intPid     The accommodations archive ID
	 * @param array   $arrOptions An optional options array
	 *
	 * @return Collection|AccommodationsModel[]|AccommodationsModel|null A collection of models or null if there are no accommodations
	 */
	public static function findPublishedDefaultByPid($intPid, array $arrOptions=array())
	{
		$t = static::$strTable;
		$arrColumns = array("$t.pid=? AND $t.source='default'");

		if (!static::isPreviewMode($arrOptions))
		{
			$time = Date::floorToMinute();
			$arrColumns[] = "($t.start='' OR $t.start<='$time') AND ($t.stop='' OR $t.stop>'" . ($time + 60) . "') AND $t.published='1'";
		}

		if (!isset($arrOptions['order']))
		{
			$arrOptions['order'] = "$t.sorting DESC";
		}

		return static::findBy($arrColumns, $intPid, $arrOptions);
	}

	/**
	 * Find published accommodations items by their parent ID
	 *
	 * @param integer $intId      The accommodations archive ID
	 * @param integer $intLimit   An optional limit
	 * @param array   $arrOptions An optional options array
	 *
	 * @return Collection|AccommodationsModel[]|AccommodationsModel|null A collection of models or null if there are no accommodations
	 */
	public static function findPublishedByPid($intId, $intLimit=0, array $arrOptions=array())
	{
		$t = static::$strTable;
		$arrColumns = array("$t.pid=?");

		if (!static::isPreviewMode($arrOptions))
		{
			$time = Date::floorToMinute();
			$arrColumns[] = "($t.start='' OR $t.start<='$time') AND ($t.stop='' OR $t.stop>'" . ($time + 60) . "') AND $t.published='1'";
		}

		if (!isset($arrOptions['order']))
		{
			$arrOptions['order'] = "$t.sorting DESC";
		}

		if ($intLimit > 0)
		{
			$arrOptions['limit'] = $intLimit;
		}

		return static::findBy($arrColumns, $intId, $arrOptions);
	}

	/**
	 * Find all published accommodations items of a certain period of time by their parent ID
	 *
	 * @param integer $intFrom    The start date as Unix timestamp
	 * @param integer $intTo      The end date as Unix timestamp
	 * @param array   $arrPids    An array of accommodations archive IDs
	 * @param integer $intLimit   An optional limit
	 * @param integer $intOffset  An optional offset
	 * @param array   $arrOptions An optional options array
	 *
	 * @return Collection|AccommodationsModel[]|AccommodationsModel|null A collection of models or null if there are no accommodations
	 */
	public static function findPublishedFromToByPids($intFrom, $intTo, $arrPids, $intLimit=0, $intOffset=0, array $arrOptions=array())
	{
		if (empty($arrPids) || !\is_array($arrPids))
		{
			return null;
		}

		$t = static::$strTable;
		$arrColumns = array("$t.pid IN(" . implode(',', array_map('\intval', $arrPids)) . ")");

		if (!static::isPreviewMode($arrOptions))
		{
			$time = Date::floorToMinute();
			$arrColumns[] = "($t.start='' OR $t.start<='$time') AND ($t.stop='' OR $t.stop>'" . ($time + 60) . "') AND $t.published='1'";
		}

		if (!isset($arrOptions['order']))
		{
			$arrOptions['order']  = "$t.sorting DESC";
		}

		$arrOptions['limit']  = $intLimit;
		$arrOptions['offset'] = $intOffset;

		return static::findBy($arrColumns, array($intFrom, $intTo), $arrOptions);
	}

	/**
	 * Count all published accommodations items of a certain period of time by their parent ID
	 *
	 * @param integer $intFrom    The start date as Unix timestamp
	 * @param integer $intTo      The end date as Unix timestamp
	 * @param array   $arrPids    An array of accommodations archive IDs
	 * @param array   $arrOptions An optional options array
	 *
	 * @return integer The number of accommodations items
	 */
	public static function countPublishedFromToByPids($intFrom, $intTo, $arrPids, array $arrOptions=array())
	{
		if (empty($arrPids) || !\is_array($arrPids))
		{
			return null;
		}

		$t = static::$strTable;
		$arrColumns = array("$t.pid IN(" . implode(',', array_map('\intval', $arrPids)) . ")");

		if (!static::isPreviewMode($arrOptions))
		{
			$time = Date::floorToMinute();
			$arrColumns[] = "($t.start='' OR $t.start<='$time') AND ($t.stop='' OR $t.stop>'" . ($time + 60) . "') AND $t.published='1'";
		}

		return static::countBy($arrColumns, array($intFrom, $intTo), $arrOptions);
	}
}

class_alias(AccommodationsModel::class, 'AccommodationsModel');
